# This program generates the different packet drop patterns, given
# the length of the targetted connection in packets

def double_drop(a, b):
	p = []
	for x in xrange(a, b):
		for y in xrange(x + 1, b):
			p.append([x, y])
	return p

def triple_drop(a, b):
	p = []
	for x in xrange(a, b):
		for y in xrange(x + 1, b):
			for z in xrange(y + 1, b):
				p.append([x, y, z])
	return p

def packetpattern(begin, end):
	patterns = []

	# Single packet drops
	for x in xrange(begin, end):
		patterns.append(str(x))

	"""
	# Double packet drop patterns
	patterns.extend(double_drop(1, ends))
	patterns.extend(double_drop(count - ends, count))

	patterns.extend(triple_drop(1, ends))
	patterns.extend(triple_drop(count - ends, count))
	"""

	return patterns

def dual_packetpattern(countA, countB):
	dual_pattern = set()
	patternA = packetpattern(0, 5)
	for pattern in patternA:
		dual_pattern.add((pattern, '0'))
	patternB = packetpattern(0, 5)
	for pattern in patternA:
		dual_pattern.add(('0', pattern))
	for patA in patternA:
		for patB in patternB:
			dual_pattern.add((patA, patB))
	patternA = packetpattern(countA - 6, countA)
	for pattern in patternA:
		dual_pattern.add((pattern, '0'))
	patternB = packetpattern(countB - 6, countB)
	for pattern in patternB:
		dual_pattern.add(('0', pattern))
	for patA in patternA:
		for patB in patternB:
			dual_pattern.add((patA, patB))
	listver = list(dual_pattern)
	listver.sort()
	return listver

