import commands
import signal
import socket
import sys
import time

datasize = 2**16
timeout = 15

def alarm_handler(arg1, arg2):
	print timeout, "second timeout; exiting."
	sys.exit(1)

rv = commands.getstatusoutput("netstat -na | grep 10000 | grep LISTEN")
if rv[0] == 256:
	print "Error, either netstat or the server is not working!"
	sys.exit(1)
signal.signal(signal.SIGALRM, alarm_handler)
signal.alarm(timeout)

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.connect((sys.argv[1], 10000))
total = 0
# This hangs sometimes with data in the recv-q - probably
#some sort of MSG_WAITALL bug.  Should set an alarm
#to handle this case.
while total < datasize:
	data = sock.recv(datasize, socket.MSG_WAITALL)
	total += len(data)
time.sleep(1)
sock.close()
# Loop for up to 90 seconds waiting for FIN_WAIT sockets and
# friends to clear out.
loops = 0
while loops < (90 * 2):
	rv = commands.getstatusoutput("netstat -na | grep 10000 | grep -v TIME_WAIT | grep -v LISTEN")
	if rv[0] == 256:
		break
	else:
		time.sleep(.5)
		loops += 1
 
print "%s loops, %s bytes received" % (loops, total)
